/*
 *  cellloader.h
 *  DendriteAnalyzer
 *
 *  Created by Philip Julian  Broser on Thu Jan 29 2004.
 *  Copyright (c) 2004 Max-Planck-Institut fuer medizinische Forschung. All rights reserved.
 * Jahnstrasse 29, D-69120 Heidelberg, EMail: philip.broser@mpimf-heidelberg.mpg.de
 */
 
 
#include "nervecell.h"

#include <iostream>
using namespace std;
#define ERROR_READIND_FILE -1

class CellLoader 
{
public:
    CellLoader();
    int LoadHocFile(const char *name);
    int WriteHocFile(char *name);
    Cellbody *AccessCellbody() {return cellBody;};
    
    double MaximumDistanceFromCellbody();
   
    
    bla::Vector<double> GetCellbodyPosition();
    
    Structure *SearchStructureByName(char *name);
     list<Structure*> GetStructureList() {return structureList;};


public:
	float d1, d2, d3;
	 
	 
private:
    
    bool message;
    
    Link *SearchLinkByName(char *name);
    int SetActivStructure(char *name);
    int SetActiveLink(char *name);
    int ConnectStructures(char *name1, double param1, char *name2, double param2);
    int ClearStructure(char *name);
    int CreateStructure(char *name, int kind);
    Link *CreateLink(char *Name, Structure *proximalStructure);
    int AddPoint3D(double x, double y, double z, double radius);
    
       
    list<Link*> linkList;
    list<Structure*> structureList;
    Link* activeLink;
    Structure *activeStructure;
    Cellbody *cellBody;
};

