//Itk Includes

#if defined(_MSC_VER)
#pragma warning ( disable : 4786 )
#endif

#include "itkImage.h"
#include <iostream>
#include <stdlib.h>
// zum Lesen und Schreiben von Bildern
#include "itkImageFileReader.h"
#include "itkImageFileWriter.h"
// for einfache Filter
//#include "itkBinaryThresholdImageFilter.h"
//#include "itkThresholdImageFilter.h"
//#include "itkSigmoidImageFilter.h"
// for Morphologie Filter
/*
#include "itkGrayscaleErodeImageFilter.h"
#include "itkGrayscaleDilateImageFilter.h"
#include "itkBinaryBallStructuringElement.h"
#include "itkSubtractImageFilter.h"
#include "itkRGBPixel.h"
*/
// m Lesen und schreiben von Stacks
//#include "itkImageSeriesReader.h"
//#include "itkImageSeriesWriter.h"
//#include "itkNumericSeriesFileNames.h"
#include "itkTIFFImageIO.h"
//#include "itkBMPImageIO.h"
//#include "itkPNGImageIO.h"
#include "itkRGBPixel.h"
//#include "itkCastImageFilter.h"
#include "itkRescaleIntensityImageFilter.h"





using namespace std;

#define PI 3.1415926
#include "nervecell.h"
#include "cellloader.h"



//Definition of itk Types
  typedef unsigned int		 FluorValueDataType;
  #define FLUORVALUEDATATYPEMAXVALUE 8192
  typedef unsigned int 		 PixelType12bit;
  typedef unsigned char 	 PixelType8bit;
  typedef itk::RGBPixel < unsigned char > PixelTypeColor8bit;
  
  const unsigned int             Dimension = 3; 

  typedef itk::Image< PixelType12bit, Dimension >       InputImageType;
  typedef itk::Image< PixelType8bit, Dimension >       GrayImageType;

  typedef itk::Image< PixelTypeColor8bit, Dimension > 	ColorImageType;


  typedef itk::ImageFileReader< InputImageType >			ReaderType;
  typedef itk::ImageFileWriter< ColorImageType >			WriterType;
  
  typedef itk::ImageRegionConstIterator< GrayImageType > GrayConstIteratorType;
  typedef itk::ImageRegionIterator< ColorImageType > ColorIteratorType;

	




enum TypeOfMeasuring {PointValue, FiveQMSurrounding, Max, EXPDecay, TopHat};


//This will me moved into a class 
CellLoader cellLoader;//Hoc File Loader
bla::Vector<float> spaceing(3); 
InputImageType::Pointer inputImage;
ColorImageType::Pointer controllImage;
char baseFilename[2048];
char outputImageFilename[2048];
float physicalScanningRangeQMXY;
float physicalScanningRangeQMZ;
float expdecayqmXY;
float expdecayqmZ;

FluorValueDataType GetFluorData(int x, int y, int z)
{
	InputImageType::RegionType region;
	InputImageType::SizeType size;
	
	region= inputImage->GetRequestedRegion();
	size = region.GetSize();
	if ((x>=size[0] || y>=size[1] || z>=size[2]) || (x<0 || y<0 ||z<0))
	{
		//cout << "Access Without Valid Range:" << x << ", " << y << ", "<< z << " " << endl;
		return 0;
	};
	
		
	InputImageType::IndexType pixelIndex;
	pixelIndex[0]=x;
	pixelIndex[1]=y;
	pixelIndex[2]=z;
	
	//Return Pixel Value
	return inputImage->GetPixel(pixelIndex);
}


FluorValueDataType GetSmoothFluorData(int x, int y, int z, int sizeXY, int sizeZ)
{
	FluorValueDataType smoothData=0;
	int counter=0;
	for(int dx=-sizeXY;dx<=sizeXY;dx++)
			for(int dy=-sizeXY;dy<=sizeXY;dy++)
				for(int dz=-sizeZ;dz<=sizeZ;dz++)
				{
					 smoothData+=GetFluorData(x+dx, y+dy, z+dz);
					counter++;
				};
	return smoothData/counter;
}


FluorValueDataType GetDataAndSetControll(int x, int y, int z)
{
	InputImageType::RegionType region;
	InputImageType::SizeType size;
	
	region= inputImage->GetRequestedRegion();
	size = region.GetSize();
	if ((x>=size[0] || y>=size[1] || z>=size[2]) || (x<0 || y<0 ||z<0))
	{
		//cout << "Access Without Valid Range:" << x << ", " << y << ", "<< z << " " << endl;
		return 0;
	};
	
		
	InputImageType::IndexType pixelIndex;
	pixelIndex[0]=x;
	pixelIndex[1]=y;
	pixelIndex[2]=z;
	
	
	
	
	//Set Controll Signal in red channel
	ColorImageType::PixelType colorPixelValue= controllImage->GetPixel(pixelIndex);
	colorPixelValue[0]=255;
	controllImage->SetPixel(pixelIndex ,colorPixelValue); 

	//Return Pixel Value
	return inputImage->GetPixel(pixelIndex);
}


void MarkInGreenChannel(int x, int y, int z)
{
	InputImageType::IndexType pixelIndex;
	pixelIndex[0]=x;
	pixelIndex[1]=y;
	pixelIndex[2]=z;
	
	//Mark in Green channel
	ColorImageType::PixelType colorPixelValue= controllImage->GetPixel(pixelIndex);
	colorPixelValue[1]=255;
	controllImage->SetPixel(pixelIndex ,colorPixelValue); 

	
	return;
}


//Top Hat Type Measuring

FluorValueDataType GetMinAroundPosition(int logicalX, int logicalY, int logicalZ, int sizeXY, int sizeZ)
{
	FluorValueDataType temp= FLUORVALUEDATATYPEMAXVALUE;
	
		for(int x=-sizeXY;x<=sizeXY;x++)
			for(int y=-sizeXY;y<=sizeXY;y++)
				for(int z=-sizeZ;z<=sizeZ;z++)
				{
					if (temp > GetFluorData(logicalX+x, logicalY+y, logicalZ+z))
						temp= GetFluorData(logicalX+x, logicalY+y, logicalZ+z);
				};
	return temp;
};

FluorValueDataType GetOpenValueAroundPosition(int logicalX, int logicalY, int logicalZ, int sizeXY, int sizeZ)
{
	FluorValueDataType openVal= 0;
	
		for(int x=-sizeXY;x<=sizeXY;x++)
			for(int y=-sizeXY;y<=sizeXY;y++)
				for(int z=-sizeZ;z<=sizeZ;z++)
				{
					FluorValueDataType temp=GetMinAroundPosition(logicalX+x, logicalY+y, logicalZ+z, sizeXY, sizeZ);
					if (temp > openVal ) openVal=temp;
					
				};
	return openVal;
};

FluorValueDataType GetTopHatValueAroundPosition(int logicalX, int logicalY, int logicalZ, int sizeXY, int sizeZ)
{
		return GetFluorData(logicalX, logicalY, logicalZ)-GetOpenValueAroundPosition( logicalX, logicalY, logicalZ, sizeXY, sizeZ);

};







// End Top Hat Type Measuring













float GetFluorValueAtPosition(TypeOfMeasuring typeOfMeasuring, int logicalX, int logicalY, int logicalZ)
{
    
    
    

    int dx=  (int)   ((float) physicalScanningRangeQMXY/spaceing[1]);
    int dy=  (int)   ((float) physicalScanningRangeQMXY/spaceing[2]);
    int dz=  (int)   ((float) physicalScanningRangeQMZ/spaceing[3]);
   // float expwideZ=physicalScanningRangeQMZ/10.0;
   // float expwideXY=physicalScanningRangeQMXY/10.0;
    
    float fluorValue=0.0;
    
    if (typeOfMeasuring==PointValue)
    {
	
	fluorValue=GetDataAndSetControll(logicalX, logicalY, logicalZ);
	
	
	
    };
    
    if (typeOfMeasuring==FiveQMSurrounding)
    {
	int counter=0;
	for(int x=-dx;x<=dx;x++)
	    for(int y=-dy;y<=dy;y++)
		for(int z=-dz;z<=dz;z++)
		{
		    counter++;
		    fluorValue+=GetDataAndSetControll(logicalX+x, logicalY+y, logicalZ+z);
		};
	fluorValue=fluorValue/(float) counter;	    
	
	
    }
    
    if (typeOfMeasuring==EXPDecay)
    {
	double expmeas=0;
	int counter=0;
	for(int x=-dx;x<=dx;x++)
	    for(int y=-dy;y<=dy;y++)
		for(int z=-dz;z<=dz;z++)
		{
		    
		    float xqm=(float) x*spaceing[1];
		    float yqm=(float) y*spaceing[2];
		    float zqm=(float) z*spaceing[3];
		    
		    
		    //Note: Idea here is convolution of (Int(-inf,inf)(exp(-(x*x+y*y+z*z)/(a*a) )*fluorvalue)dxdydz , Int(-inf,inf)(exp(-dx*dx+.../(a*a)))=a*a*a*sqrt(PI*PI*PI)
		    //Calc is done in qm!!!
		    double help=GetDataAndSetControll(logicalX+x, logicalY+y, logicalZ+z);
		    double valueInExp=-1.0*( ((xqm*xqm)+(yqm*yqm))/ ( expdecayqmXY* expdecayqmXY) + ((zqm*zqm)/( expdecayqmZ* expdecayqmZ)) );
		    expmeas+=exp(valueInExp);
		    fluorValue+=help*exp(valueInExp);
		    counter++;
		};
	    fluorValue= ((double) fluorValue/expmeas);
		


    }











if (typeOfMeasuring==Max)
{
    int counter=0;
    int mx=0, my=0, mz=0;
    for(int x=-dx;x<=dx;x++)
	for(int y=-dy;y<=dy;y++)
	    for(int z=-dz;z<=dz;z++)
	    {
		counter++;
		float present=GetDataAndSetControll(logicalX+x, logicalY+y, logicalZ+z);
		
		
		if (present>fluorValue) 
		{
		    mx=x;my=y;mz=z;
		    fluorValue=present;
		}
		
	    };
    
    //Mark Max in Green
    MarkInGreenChannel(logicalX+mx, logicalY+my, logicalZ+mz);	
    
}


if (typeOfMeasuring==TopHat)
{
	fluorValue+GetTopHatValueAroundPosition(logicalX, logicalY, logicalZ, 5, 2);

 };




return  fluorValue;
}











list<float> GetTopHatTraces(list<vector<int> > positions, int B)
{

	list<vector<int> >::iterator imagePos;
	list<float> meanValueList;
	
	//Create MeanValue List
	for (imagePos=positions.begin();imagePos!=positions.end();imagePos++)
	{
	
		float tempValue=GetFluorValueAtPosition(EXPDecay, (*imagePos)[0], (*imagePos)[1],  (*imagePos)[2]);
		meanValueList.push_back(tempValue);
		//cout <<"Pos:" << (*imagePos)[0] << "," <<  (*imagePos)[1] << "," <<   (*imagePos)[2]  << " Val=" << tempValue <<endl;
	
	};
	
	//Create Min Value List 
	list<float>::iterator meanPos;
	list<float> minValueList;
	for (meanPos=meanValueList.begin();meanPos!=meanValueList.end();meanPos++)
	{
		float tmpMin=*meanPos;
		//Forward Search 
		list<float>::iterator meanPos2;
		meanPos2=meanPos;
		int i=1;
		while (i<=B && meanPos2!=meanValueList.end()) 
		{
			if ((*meanPos2)<tmpMin) tmpMin=(*meanPos2);
			meanPos2++;
			i++;
		};
		//Backward Search 
		meanPos2=meanPos;
		i=1;
		while (i<=B && meanPos2!=meanValueList.begin()) 
		{
			if ((*meanPos2)<tmpMin) tmpMin=(*meanPos2);
			meanPos2--;
			i++;
		};
		minValueList.push_back(tmpMin);
	};

	
	//Create MinMaxValueList=OpenList
	
	list<float>::iterator minPos;
	list<float> maxValueList;
	for (minPos=minValueList.begin();minPos!=minValueList.end();minPos++)
	{
		float tmpMax=*minPos;
		//Forward Search 
		list<float>::iterator minPos2;
		minPos2=minPos;
		int i=1;
		while (i<=B && minPos2!=minValueList.end()) 
		{
			if ((*minPos2)>tmpMax) tmpMax=(*minPos2);
			minPos2++;
			i++;
		};
		//Backward Search 
		minPos2=minPos;
		i=1;
		while (i<=B && minPos2!=minValueList.begin()) 
		{
			if ((*minPos2)>tmpMax) tmpMax=(*minPos2);
			minPos2--;
			i++;
		};
		maxValueList.push_back(tmpMax);
	};

	
	//Calc Top Hat List
	list<float>::iterator maxPos;
	list<float> TopHatValueList;

 //
	
	for (maxPos=maxValueList.begin(),meanPos=meanValueList.begin();(maxPos!=maxValueList.end() && meanPos!=meanValueList.end()) ; maxPos++,meanPos++)
	{
	float tempTopHatVal=(*meanPos)-(*maxPos);
	TopHatValueList.push_back(tempTopHatVal);
	//cout << "TopHatVal:" << tempTopHatVal << endl;
	
	};
	

	return TopHatValueList;
}

















int gnuPlotFile(int dendNr)
{
	char baseName[1024];
    sprintf(baseName,"%s.Dendrite%d",baseFilename, dendNr);
    char gnuPlotDataFileName[100];
    char gnuPlotExecuteFileName[100];
//    char gnuPlotPSName[100];
    sprintf(gnuPlotDataFileName,"%s.dat",baseName);
    sprintf(gnuPlotExecuteFileName,"%s.gnuplot",baseName);
    FILE *gnuPlotFile;
    FILE *gnuPlotExecuteFile;
    gnuPlotFile=fopen(gnuPlotDataFileName,"w");
    gnuPlotExecuteFile=fopen(gnuPlotExecuteFileName,"w");
    if ( gnuPlotFile==NULL || gnuPlotExecuteFile==NULL) {printf("Error Opening File\n");return 1;}
    
    fprintf(gnuPlotExecuteFile,"set title \"Dendrite%d\" 0,0\n", dendNr);
    //fprintf(gnuPlotExecuteFile,"set term post \n");
    //fprintf(gnuPlotExecuteFile,"set out \"%s\" \n",gnuPlotPSName);
    fprintf(gnuPlotExecuteFile, "plot '%s' using 1:5 t \"%s\" with lines", gnuPlotDataFileName, baseName);
    fprintf(gnuPlotExecuteFile, ", '%s' using 1:6 t \"%s\" with lines", gnuPlotDataFileName, "fluorPoint");
    fprintf(gnuPlotExecuteFile, ", '%s' using 1:7 t \"%s\" with lines", gnuPlotDataFileName, "fluorFiveQMSurrounding");
    fprintf(gnuPlotExecuteFile, ", '%s' using 1:8 t \"%s\" with lines\n", gnuPlotDataFileName, "fluorMaxSurrounding");
    
    char buffer3[1024];
    sprintf(buffer3,"Dendrite%d",dendNr);
    Structure* dendrite=cellLoader.SearchStructureByName(buffer3);
    if (dendrite==NULL)
    {
	cout << "Cant find structure with name " << buffer3 << "  !" << endl;
	return 1;
    }
    list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
    list< bla::Vector<double> >::iterator pos2;
    int nr=0;
    for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2)
	{
	nr++;
	
	
	bla::Vector<double> pos3d(4);//This will be the Logical Position!
	pos3d[1]=(*pos2)[1]/spaceing[1];
	pos3d[2]=(*pos2)[2]/spaceing[2];
	pos3d[3]=(*pos2)[3]/spaceing[3];
	pos3d[4]=(*pos2)[4];
	int lX=(int) pos3d[1];
	int lY=(int) pos3d[2];
	int lZ=(int) pos3d[3];
	
	
	
	
	cout << pos3d[1] << "," << pos3d[2] << "," << pos3d[3] << ":FluorSignal:" << pos3d[4] << endl;
	char buffer[1024];
	
	float fluorHoc=pos3d[4];
	float fluorPoint=GetFluorValueAtPosition(PointValue, lX,lY,lZ );
	float fluorFiveQMSurrounding=GetFluorValueAtPosition(FiveQMSurrounding, lX,lY,lZ);
	float fluorMax=GetFluorValueAtPosition(Max, lX,lY,lZ);
	sprintf(buffer,"%d %d %d %d %f %f %f %f\n",nr,lX,lY,lZ,fluorHoc, fluorPoint, fluorFiveQMSurrounding,fluorMax);
	fprintf(gnuPlotFile, buffer);
	};
       
    fprintf(gnuPlotExecuteFile,"\npause -1 \"Press Return\"\n");
    fprintf(gnuPlotFile,"\n");
    fclose(gnuPlotFile);
    fclose(gnuPlotExecuteFile);
    
    return 0;
}




int IGORFileForDendList(list<int> dendNumbers)
{
    // char baseName[100];
    char IgorWavesDataFileName[8192];
    sprintf(IgorWavesDataFileName,"%s_IGORWaves/%s_L",baseFilename,baseFilename);
    
    list<int>::iterator dendriticComps;
    for (dendriticComps=dendNumbers.begin();dendriticComps!=dendNumbers.end(); dendriticComps++)
	sprintf(IgorWavesDataFileName,"%sD%d",IgorWavesDataFileName,(*dendriticComps));
    
    sprintf(IgorWavesDataFileName,"%s.txt",IgorWavesDataFileName);
    
    
    
    
    ofstream IgorWavesDataFile(IgorWavesDataFileName);
    if ( !IgorWavesDataFile ) {printf("Error Opening File\n");return 1;}
    
    
    IgorWavesDataFile<< "IGOR" << endl;
    
    /*
     WAVES/D waveZero1a
     BEGIN
     1	
     2
     3	
     4
     5	
     6
     END
     */
    
    
    //Create Data Streams
    const int maxBufferSize=100000;
    ostrstream positionXStream(new char[maxBufferSize], maxBufferSize);
    ostrstream positionYStream(new char[maxBufferSize], maxBufferSize);
    ostrstream positionZStream(new char[maxBufferSize], maxBufferSize);
    ostrstream lengthStream(new char[maxBufferSize], maxBufferSize);
    ostrstream radiusStream(new char[maxBufferSize], maxBufferSize);
    ostrstream pointValueStream(new char[maxBufferSize], maxBufferSize);
    ostrstream meanValueStream(new char[maxBufferSize], maxBufferSize);
    ostrstream maxValueStream(new char[maxBufferSize], maxBufferSize);
    ostrstream EXPDecayValueStream(new char[maxBufferSize], maxBufferSize);
	ostrstream topHatValueStream(new char[maxBufferSize], maxBufferSize);
	
    //Initalize Waves 
    
    positionXStream << "WAVES/D W"<< baseFilename << "XPosList" << endl << "BEGIN" << endl;
    positionYStream << "WAVES/D W"<< baseFilename << "YPosList" << endl << "BEGIN" << endl;
    positionZStream << "WAVES/D W"<< baseFilename << "ZPosList" << endl << "BEGIN" << endl;
    lengthStream << "WAVES/D W"<< baseFilename << "LegList" << endl << "BEGIN" << endl;
    radiusStream << "WAVES/D W"<< baseFilename << "RadList" << endl << "BEGIN" << endl;
    pointValueStream << "WAVES/D W"<< baseFilename << "PointVList" << endl << "BEGIN" << endl;
    meanValueStream << "WAVES/D W"<< baseFilename << "MeanVList" << endl << "BEGIN" << endl;
    maxValueStream << "WAVES/D W"<< baseFilename << "MaxVList" << endl << "BEGIN" << endl;
    EXPDecayValueStream	<< "WAVES/D W"<< baseFilename << "ExpVList" << endl << "BEGIN" << endl;
    topHatValueStream<< "WAVES/D W"<< baseFilename << "TopHatVList" << endl << "BEGIN" << endl;
    
    
    int nr=0;
    float lenghth=0.0;
    int oldX=0;
    int oldY=0;
    int oldZ=0;
    
	
	
	list <vector<int> > topHatPositions;
    for (dendriticComps=dendNumbers.begin();dendriticComps!=dendNumbers.end(); dendriticComps++)
    {
	
	int dendNr=(*dendriticComps);
	char buffer3[1024];
	sprintf(buffer3,"Dendrite%d",dendNr);
	Structure* dendrite=cellLoader.SearchStructureByName(buffer3);
	if (dendrite==NULL)
	{
	    cout << "Cant find structure with name " << buffer3 << "  !" << endl;
	    return 1;
	}
	cout << "Next Dendrite:" <<  buffer3 << endl;
	
	
	//Write Data to Streams
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2)
	{
	    nr++;
	    
	    
	    bla::Vector<double> pos3d(4);//This will be the Logical Position!
		pos3d[1]=(*pos2)[1]/spaceing[1];
		pos3d[2]=(*pos2)[2]/spaceing[2];
		pos3d[3]=(*pos2)[3]/spaceing[3];
		pos3d[4]=(*pos2)[4];
		int lX=(int) pos3d[1];
		int lY=(int) pos3d[2];
		int lZ=(int) pos3d[3];
		
		//cout << pos3d[1] << "," << pos3d[2] << "," << pos3d[3] << ":FluorSignal:" << pos3d[4] << endl;
		//char buffer[1024];
		
		float radiusHoc=pos3d[4];
		float fluorPoint=GetFluorValueAtPosition(PointValue, lX,lY,lZ );
		float fluorFiveQMSurrounding=GetFluorValueAtPosition(FiveQMSurrounding, lX,lY,lZ);
		float fluorMax=GetFluorValueAtPosition(Max, lX,lY,lZ);
		float expDecay=GetFluorValueAtPosition(EXPDecay, lX,lY,lZ );
		
		
		
		vector<int> posV;
		posV.push_back(lX);
		posV.push_back(lY);
		posV.push_back(lZ);
		topHatPositions.push_back(posV);
		
		positionXStream << lX << endl;
		positionYStream << lY << endl;
		positionZStream << lZ << endl;
		//
		
		if (oldX>0) 
		    lenghth=lenghth+sqrt((float)(lX-oldX)*(lX-oldX)+(lY-oldY)*(lY-oldY)+(lZ-oldZ)*(lZ-oldZ));
		
		oldX=lX;
		oldY=lY;
		oldZ=lZ;
		
		//
		lengthStream << lenghth << endl;
		radiusStream << radiusHoc << endl;
		pointValueStream << fluorPoint << endl;
		meanValueStream << fluorFiveQMSurrounding << endl;
		maxValueStream << fluorMax << endl;
		EXPDecayValueStream << expDecay << endl;
		//topHatValueStream<< topHat << endl;
	};
    }
    
	 list <float> topHatTraces= GetTopHatTraces(topHatPositions, 10);
	list<float>::iterator tracePos;
		
	for (tracePos=topHatTraces.begin();tracePos!=topHatTraces.end();tracePos++)
	{
		float fluorTopHat=(*tracePos); 
		topHatValueStream<< fluorTopHat << endl;
	};    

    //Finish Waves 
    positionXStream << "END" << endl;
    positionYStream << "END" << endl;
    positionZStream << "END" << endl;
    lengthStream << "END" << endl;
    radiusStream << "END" << endl;
    pointValueStream << "END" << endl;
    meanValueStream << "END" << endl;
    maxValueStream << "END" << endl;
    EXPDecayValueStream << "END" << endl;
    topHatValueStream << "END" << endl;
    //cout << "Pos X:" << positionXStream.str () << " PointVal:" << pointValueStream.str () << endl;
    //Write To File
    IgorWavesDataFile << positionXStream.str ();
    IgorWavesDataFile << positionYStream.str ();
    IgorWavesDataFile << positionZStream.str ();
    IgorWavesDataFile <<  lengthStream.str ();
    IgorWavesDataFile << radiusStream.str ();
    IgorWavesDataFile <<  pointValueStream.str ();
    IgorWavesDataFile <<  meanValueStream.str ();
    IgorWavesDataFile <<  maxValueStream.str ();
    IgorWavesDataFile <<  EXPDecayValueStream .str ();
   IgorWavesDataFile << topHatValueStream.str ();
	 return 0;
    


};





int IGORFile(int dendNr)
{
    
  
    char baseName[1024];
    sprintf(baseName,"%s_IGORWaves/%s_Dendrite%d",baseFilename,baseFilename, dendNr);
    char IgorWavesDataFileName[100];
   
 
    sprintf(IgorWavesDataFileName,"%s.txt",baseName);
    ofstream IgorWavesDataFile(IgorWavesDataFileName);
    if ( !IgorWavesDataFile ) {printf("Error Opening File\n");return 1;}
    
    
    IgorWavesDataFile<< "IGOR" << endl;
    
    /*
     WAVES/D waveZero1a
     BEGIN
     1	
     2
     3	
     4
     5	
     6
     END
     */
    
    char buffer3[1024];
    sprintf(buffer3,"Dendrite%d",dendNr);
    Structure* dendrite=cellLoader.SearchStructureByName(buffer3);
    if (dendrite==NULL)
    {
	cout << "Cant find structure with name " << buffer3 << "  !" << endl;
	return 1;
    }
    
    
   //Create Data Streams
    const int maxBufferSize=100000;
    ostrstream positionXStream(new char[maxBufferSize], maxBufferSize);
    ostrstream positionYStream(new char[maxBufferSize], maxBufferSize);
    ostrstream positionZStream(new char[maxBufferSize], maxBufferSize);
    ostrstream lengthStream(new char[maxBufferSize], maxBufferSize);
    ostrstream radiusStream(new char[maxBufferSize], maxBufferSize);
    ostrstream pointValueStream(new char[maxBufferSize], maxBufferSize);
    ostrstream meanValueStream(new char[maxBufferSize], maxBufferSize);
    ostrstream maxValueStream(new char[maxBufferSize], maxBufferSize);
    ostrstream EXPDecayValueStream(new char[maxBufferSize], maxBufferSize);
	ostrstream topHatValueStream(new char[maxBufferSize], maxBufferSize);

    //Initalize Waves 
    positionXStream << "WAVES/D W"<< baseFilename << "XPosD"<< dendNr << endl << "BEGIN" << endl;
    positionYStream << "WAVES/D W"<< baseFilename << "YPosD"<< dendNr << endl << "BEGIN" << endl;
    positionZStream << "WAVES/D W"<< baseFilename << "ZPosD"<< dendNr << endl << "BEGIN" << endl;
    lengthStream << "WAVES/D W"<< baseFilename << "LegD"<< dendNr << endl << "BEGIN" << endl;
    radiusStream << "WAVES/D W"<< baseFilename << "RadD"<< dendNr << endl << "BEGIN" << endl;
    pointValueStream << "WAVES/D W"<< baseFilename << "PointVD"<< dendNr << endl << "BEGIN" << endl;
    meanValueStream << "WAVES/D W"<< baseFilename << "MeanVD"<< dendNr << endl << "BEGIN" << endl;
    maxValueStream << "WAVES/D W"<< baseFilename << "MaxVD"<< dendNr << endl << "BEGIN" << endl;
    EXPDecayValueStream	<< "WAVES/D W"<< baseFilename << "ExpVD"<< dendNr << endl << "BEGIN" << endl;
	topHatValueStream<< "WAVES/D W"<< baseFilename << "TopHatVList"<< dendNr << endl << "BEGIN" << endl;
  
    //Write Data to Streams
    list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
    list< bla::Vector<double> >::iterator pos2;
    int nr=0;
    float lenghth=0.0;
    int oldX=0;
    int oldY=0;
    int oldZ=0;
    
    
    
    
    list <vector<int> > topHatPositions;
    
    for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2)
    {
	nr++;
	
	
	bla::Vector<double> pos3d(4);//This will be the Logical Position!
	    pos3d[1]=(*pos2)[1]/spaceing[1];
	    pos3d[2]=(*pos2)[2]/spaceing[2];
	    pos3d[3]=(*pos2)[3]/spaceing[3];
	    pos3d[4]=(*pos2)[4];
	    int lX=(int) pos3d[1];
	    int lY=(int) pos3d[2];
	    int lZ=(int) pos3d[3];
	    
	    //cout << pos3d[1] << "," << pos3d[2] << "," << pos3d[3] << ":FluorSignal:" << pos3d[4] << endl;
	    //char buffer[1024];
	    
	    float radiusHoc=pos3d[4];
	    float fluorPoint=GetFluorValueAtPosition(PointValue, lX,lY,lZ );
	    float fluorFiveQMSurrounding=GetFluorValueAtPosition(FiveQMSurrounding, lX,lY,lZ);
	    float fluorMax=GetFluorValueAtPosition(Max, lX,lY,lZ);
	    float expDecay=GetFluorValueAtPosition(EXPDecay, lX,lY,lZ );
		
		vector<int> posV;
			posV.push_back(lX);
			posV.push_back(lY);
			posV.push_back(lZ);
			
					
		topHatPositions.push_back(posV);
		

	    positionXStream << lX << endl;
	    positionYStream << lY << endl;
	    positionZStream << lZ << endl;
	   //
	    
	    if (oldX>0) 
		lenghth=lenghth+sqrt((float)(lX-oldX)*(lX-oldX)+(lY-oldY)*(lY-oldY)+(lZ-oldZ)*(lZ-oldZ));
		
	    oldX=lX;
	    oldY=lY;
	    oldZ=lZ;
	    
	    //
	    lengthStream << lenghth << endl;
	    radiusStream << radiusHoc << endl;
	    pointValueStream << fluorPoint << endl;
	    meanValueStream << fluorFiveQMSurrounding << endl;
	    maxValueStream << fluorMax << endl;
	    EXPDecayValueStream << expDecay << endl;
		
    };
    
  list <float> topHatTraces= GetTopHatTraces(topHatPositions, 10);
		list<float>::iterator tracePos;
		
		for (tracePos=topHatTraces.begin();tracePos!=topHatTraces.end();tracePos++)
		{
			
			float fluorTopHat=(*tracePos); 
			topHatValueStream<< fluorTopHat << endl;
		}    
    
    
    
    
    
    //Finish Waves 
    positionXStream << "END" << endl;
    positionYStream << "END" << endl;
    positionZStream << "END" << endl;
    lengthStream << "END" << endl;
    radiusStream << "END" << endl;
    pointValueStream << "END" << endl;
    meanValueStream << "END" << endl;
    maxValueStream << "END" << endl;
    EXPDecayValueStream << "END" << endl;
	  topHatValueStream << "END" << endl;
    
    //cout << "Pos X:" << positionXStream.str () << " PointVal:" << pointValueStream.str () << endl;
    //Write To File
    IgorWavesDataFile << positionXStream.str ();
    IgorWavesDataFile << positionYStream.str ();
    IgorWavesDataFile << positionZStream.str ();
    IgorWavesDataFile <<  lengthStream.str ();
    IgorWavesDataFile << radiusStream.str ();
    IgorWavesDataFile <<  pointValueStream.str ();
    IgorWavesDataFile <<  meanValueStream.str ();
    IgorWavesDataFile <<  maxValueStream.str ();
    IgorWavesDataFile <<  EXPDecayValueStream .str ();
	IgorWavesDataFile << topHatValueStream.str ();
	
    return 0;
}














int plotValueOf(int dendNr)
{
    char buffer3[1024];
    sprintf(buffer3,"Dendrite%d",dendNr);
    printf(buffer3);
    Structure* dendrite=cellLoader.SearchStructureByName(buffer3);
    if (dendrite==NULL)
    {
	cout << "Cant find structure with name " << buffer3 << "  !" << endl;
	
    }
    else
    {
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2)
	{
	    bla::Vector<double> pos3d(4);
	    pos3d[1]=(*pos2)[1];
	    pos3d[2]=(*pos2)[2];
	    pos3d[3]=(*pos2)[3];
	    pos3d[4]=(*pos2)[4];
	    cout << pos3d[1] << "," << pos3d[2] << "," << pos3d[3] << ":Radius:" << pos3d[4] << endl;
	};
    }
    
    return 0;
}; 


int IsStructureInList(Structure* present_structure,  list<int> dendNumbers)
{

    list<int>::iterator dendriticComps;
    for (dendriticComps=dendNumbers.begin();dendriticComps!=dendNumbers.end(); dendriticComps++)
    {   
	 char name[100];
	sprintf(name,"Dendrite%d",*dendriticComps);
	if (present_structure->IsThisMyName(name)) return 1;
    };
    return 0;

}



int AmiraSelectedListDataWriter(list<int> dendNumbers)
{
    cout << "Open File" << endl;
    char AmiraFileName[8192];
    sprintf(AmiraFileName,"%s_AmiraList", baseFilename);
   
    list<int>::iterator dendriticComps;
    for (dendriticComps=dendNumbers.begin();dendriticComps!=dendNumbers.end(); dendriticComps++)
	sprintf(AmiraFileName,"%sD%d",AmiraFileName,(*dendriticComps));
    sprintf(AmiraFileName,"%s.am",AmiraFileName);
    
    
    
   
    FILE *AmiraFile=fopen(AmiraFileName,"w");
    int nrOfVectors=0;
    int nrOfLines=0;
    int lineCounter=0;
    int vectorCounter=0;
    
    list<Structure*> structureList=cellLoader.GetStructureList();
    list<Structure*>::iterator pos;
    
    cout << "Calcualte Nr of Entrys" << endl;
    //Calcualte Nr of Entrys;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	
	//Check if Structure is in List
	if(!(IsStructureInList(*pos,  dendNumbers))) continue;	
	
	nrOfLines++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) nrOfVectors++;
    }
    
    
    
    cout << "Write Header" << endl;
    /* Write Header */
    fprintf(AmiraFile,"# AmiraMesh ASCII 1.0\n");
    fprintf(AmiraFile,"# File Generated with FluorProjectionProgramm\n");
    fprintf(AmiraFile,"# Programmed by Philip J. Broser\n");
    fprintf(AmiraFile,"# philip.broser@mpimf-heidelberg.mpg.de\n");
    fprintf(AmiraFile,"# Data: diameter, Data1: FluorSignalPoint Data2: FluorSignalMax Data5: FluorSignalMax Data6:ExpDecay\n");
    fprintf(AmiraFile,"# Settings: (xy, z) physicalScanningRangeQM=%f %f,expdecayqm=%f %f\n", physicalScanningRangeQMXY, physicalScanningRangeQMZ, expdecayqmXY, expdecayqmZ);
    fprintf(AmiraFile,"define Lines %d\n",nrOfVectors+nrOfLines);
    fprintf(AmiraFile,"define Vertices %d\n",nrOfVectors);
    fprintf(AmiraFile,"Parameters {  ContentType \"HxLineSet\" }\n");
    fprintf(AmiraFile,"Vertices { float[3] Coordinates } = @1\n");
    fprintf(AmiraFile,"Vertices { float Data } = @2\n");
    fprintf(AmiraFile,"Vertices { float Data1 } = @3\n");
    fprintf(AmiraFile,"Vertices { float Data2 } = @4\n");
    fprintf(AmiraFile,"Vertices { float Data3 } = @5\n"); 
    fprintf(AmiraFile,"Vertices { float Data4 } = @6\n"); 
    fprintf(AmiraFile,"Lines { int LineIdx } = @7\n");
    
    
    cout << "Write Position" << endl;
    //Write Position;
    fprintf(AmiraFile,"@1 # Vertices xyz coordinates\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	//Check if Structure is in List
	if(!(IsStructureInList(*pos,  dendNumbers))) continue;	
	
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    //nrOfVectors++;
	    bla::Vector<double> vecPos=(*pos2);
	    fprintf(AmiraFile, "%f %f %f\n",vecPos[1],vecPos[2],vecPos[3]);
	}
    }
    
    
    
    cout << "Write Diameter" << endl;
    //Write Diamter 
    fprintf(AmiraFile,"@2 # Diameter\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	//Check if Structure is in List
	if(!(IsStructureInList(*pos,  dendNumbers))) continue;	
	
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    //nrOfVectors++;
	    bla::Vector<double> vecPos=(*pos2);
	    fprintf(AmiraFile, "%f\n",vecPos[4]);
	}
    }
    
    
    cout << "Write Fluor Signal" << endl;
    //Write Data1
    fprintf(AmiraFile,"@3 # PointFluorSignal\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	//Check if Structure is in List
	if(!(IsStructureInList(*pos,  dendNumbers))) continue;	
	
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    bla::Vector<double> pos3d(4);//This will be the Logical Position!
	    pos3d[1]=(*pos2)[1]/spaceing[1];
	    pos3d[2]=(*pos2)[2]/spaceing[2];
	    pos3d[3]=(*pos2)[3]/spaceing[3];
	    pos3d[4]=(*pos2)[4];
	    int lX=(int) pos3d[1];
	    int lY=(int) pos3d[2];
	    int lZ=(int) pos3d[3];
	    float fluorPoint=GetFluorValueAtPosition(PointValue, lX,lY,lZ );
	    
	    fprintf(AmiraFile, "%f\n",fluorPoint);
	}
    }
    
    //Write Data1
    fprintf(AmiraFile,"@4 # SuuroundingFluorSignal\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	//Check if Structure is in List
	if(!(IsStructureInList(*pos,  dendNumbers))) continue;	
	
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    
	    bla::Vector<double> pos3d(4);//This will be the Logical Position!
	    pos3d[1]=(*pos2)[1]/spaceing[1];
	    pos3d[2]=(*pos2)[2]/spaceing[2];
	    pos3d[3]=(*pos2)[3]/spaceing[3];
	    pos3d[4]=(*pos2)[4];
	    int lX=(int) pos3d[1];
	    int lY=(int) pos3d[2];
	    int lZ=(int) pos3d[3];
	    float fluorFiveQMSurrounding=GetFluorValueAtPosition(FiveQMSurrounding, lX,lY,lZ );
	    
	    fprintf(AmiraFile, "%f\n",fluorFiveQMSurrounding);
	}
    }
    
    
    //Write Data1
    fprintf(AmiraFile,"@5 # PointFluorSignal\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	//Check if Structure is in List
	if(!(IsStructureInList(*pos,  dendNumbers))) continue;	
	
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    bla::Vector<double> pos3d(4);//This will be the Logical Position!
	    pos3d[1]=(*pos2)[1]/spaceing[1];
	    pos3d[2]=(*pos2)[2]/spaceing[2];
	    pos3d[3]=(*pos2)[3]/spaceing[3];
	    pos3d[4]=(*pos2)[4];
	    int lX=(int) pos3d[1];
	    int lY=(int) pos3d[2];
	    int lZ=(int) pos3d[3];
	    float fluorMax=GetFluorValueAtPosition(Max, lX,lY,lZ );
	    
	    
	    fprintf(AmiraFile, "%f\n",fluorMax);
	}
    }
    
    //Write Data6
    fprintf(AmiraFile,"@6 # ExpDecaySignal\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	//Check if Structure is in List
	if(!(IsStructureInList(*pos,  dendNumbers))) continue;	
	
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    bla::Vector<double> pos3d(4);//This will be the Logical Position!
	    pos3d[1]=(*pos2)[1]/spaceing[1];
	    pos3d[2]=(*pos2)[2]/spaceing[2];
	    pos3d[3]=(*pos2)[3]/spaceing[3];
	    pos3d[4]=(*pos2)[4];
	    int lX=(int) pos3d[1];
	    int lY=(int) pos3d[2];
	    int lZ=(int) pos3d[3];
	    float fluorExpDecay=GetFluorValueAtPosition(EXPDecay, lX,lY,lZ );
	    
	    
	    fprintf(AmiraFile, "%f\n",fluorExpDecay);
	}
    }
    
    
    
    
    
    //WriteLines
    fprintf(AmiraFile,"@7 # LineIndex\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	//Check if Structure is in List
	if(!(IsStructureInList(*pos,  dendNumbers))) continue;	
	
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    //nrOfVectors++;
	    vectorCounter++;
	    fprintf(AmiraFile, "%d ",vectorCounter-1);
	}
	fprintf(AmiraFile,"-1\n");
    }
    
    
    
    
    fclose(AmiraFile);
    
    return 0;
}




int AmiraDataWriter()
{
	cout << "Open File" << endl;
    char AmiraFileName[1024];
    sprintf(AmiraFileName,"%s_Amira.am", baseFilename);
    FILE *AmiraFile=fopen(AmiraFileName,"w");
    int nrOfVectors=0;
    int nrOfLines=0;
    int lineCounter=0;
    int vectorCounter=0;
    
    list<Structure*> structureList=cellLoader.GetStructureList();
    list<Structure*>::iterator pos;
    
	cout << "Calcualte Nr of Entrys" << endl;
    //Calcualte Nr of Entrys;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	nrOfLines++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) nrOfVectors++;
    }
    
    
    
    cout << "Write Header" << endl;
    /* Write Header */
    fprintf(AmiraFile,"# AmiraMesh ASCII 1.0\n");
    fprintf(AmiraFile,"# File Generated with FluorProjectionProgramm\n");
    fprintf(AmiraFile,"# Programmed by Philip J. Broser\n");
    fprintf(AmiraFile,"# philip.broser@mpimf-heidelberg.mpg.de\n");
    fprintf(AmiraFile,"# Data: diameter, Data1: FluorSignalPoint Data2: FluorSignalMax Data5: FluorSignalMax Data6:ExpDecay\n");
    fprintf(AmiraFile,"# Settings: (xy, z) physicalScanningRangeQM=%f %f,expdecayqm=%f %f\n", physicalScanningRangeQMXY, physicalScanningRangeQMZ, expdecayqmXY, expdecayqmZ);
    fprintf(AmiraFile,"define Lines %d\n",nrOfVectors+nrOfLines);
    fprintf(AmiraFile,"define Vertices %d\n",nrOfVectors);
    fprintf(AmiraFile,"Parameters {  ContentType \"HxLineSet\" }\n");
    fprintf(AmiraFile,"Vertices { float[3] Coordinates } = @1\n");
    fprintf(AmiraFile,"Vertices { float Data } = @2\n");
    fprintf(AmiraFile,"Vertices { float Data1 } = @3\n");
    fprintf(AmiraFile,"Vertices { float Data2 } = @4\n");
    fprintf(AmiraFile,"Vertices { float Data3 } = @5\n"); 
    fprintf(AmiraFile,"Vertices { float Data4 } = @6\n"); 
    fprintf(AmiraFile,"Vertices { float Data5 } = @7\n"); 
	fprintf(AmiraFile,"Vertices { float Data6 } = @8\n"); 
    fprintf(AmiraFile,"Lines { int LineIdx } = @9\n");
   
    
     cout << "Write Position" << endl;
    //Write Position;
    fprintf(AmiraFile,"@1 # Vertices xyz coordinates\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    //nrOfVectors++;
	    bla::Vector<double> vecPos=(*pos2);
	    fprintf(AmiraFile, "%f %f %f\n",vecPos[1],vecPos[2],vecPos[3]);
	}
    }
    
	
	
	 cout << "Write Diameter" << endl;
    //Write Diamter 
    fprintf(AmiraFile,"@2 # Diameter\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    //nrOfVectors++;
	    bla::Vector<double> vecPos=(*pos2);
	    fprintf(AmiraFile, "%f\n",vecPos[4]);
	}
    }


	cout << "Write Point Fluor Signal" << endl;
    //Write Data1
    fprintf(AmiraFile,"@3 # PointFluorSignal\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    bla::Vector<double> pos3d(4);//This will be the Logical Position!
		pos3d[1]=(*pos2)[1]/spaceing[1];
		pos3d[2]=(*pos2)[2]/spaceing[2];
		pos3d[3]=(*pos2)[3]/spaceing[3];
		pos3d[4]=(*pos2)[4];
		int lX=(int) pos3d[1];
		int lY=(int) pos3d[2];
		int lZ=(int) pos3d[3];
		float fluorPoint=GetFluorValueAtPosition(PointValue, lX,lY,lZ );
		
	    fprintf(AmiraFile, "%f\n",fluorPoint);
	}
    }
    
	cout << "Write Mean Fluor Signal" << endl;
    //Write Data1
    fprintf(AmiraFile,"@4 # SuuroundingFluorSignal\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    
	    bla::Vector<double> pos3d(4);//This will be the Logical Position!
		pos3d[1]=(*pos2)[1]/spaceing[1];
		pos3d[2]=(*pos2)[2]/spaceing[2];
		pos3d[3]=(*pos2)[3]/spaceing[3];
		pos3d[4]=(*pos2)[4];
		int lX=(int) pos3d[1];
		int lY=(int) pos3d[2];
		int lZ=(int) pos3d[3];
		float fluorFiveQMSurrounding=GetFluorValueAtPosition(FiveQMSurrounding, lX,lY,lZ );
		
	    fprintf(AmiraFile, "%f\n",fluorFiveQMSurrounding);
	}
    }
    
    cout << "Write Max Fluor Signal" << endl;
    //Write Data1
    fprintf(AmiraFile,"@5 # MaxFluorSignal\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	   bla::Vector<double> pos3d(4);//This will be the Logical Position!
		pos3d[1]=(*pos2)[1]/spaceing[1];
		pos3d[2]=(*pos2)[2]/spaceing[2];
		pos3d[3]=(*pos2)[3]/spaceing[3];
		pos3d[4]=(*pos2)[4];
		int lX=(int) pos3d[1];
		int lY=(int) pos3d[2];
		int lZ=(int) pos3d[3];
		float fluorMax=GetFluorValueAtPosition(Max, lX,lY,lZ );

	    
	    fprintf(AmiraFile, "%f\n",fluorMax);
	}
    }
    
	cout << "Write Exp Decay Fluor Signal" << endl;
    //Write Data6
    fprintf(AmiraFile,"@6 # ExpDecaySignal\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    bla::Vector<double> pos3d(4);//This will be the Logical Position!
	    pos3d[1]=(*pos2)[1]/spaceing[1];
	    pos3d[2]=(*pos2)[2]/spaceing[2];
	    pos3d[3]=(*pos2)[3]/spaceing[3];
	    pos3d[4]=(*pos2)[4];
	    int lX=(int) pos3d[1];
	    int lY=(int) pos3d[2];
	    int lZ=(int) pos3d[3];
	    float fluorExpDecay=GetFluorValueAtPosition(EXPDecay, lX,lY,lZ );
	    
	    
	    fprintf(AmiraFile, "%f\n",fluorExpDecay);
	}
    }
    
	
	cout << "Write Top Hat Fluor Signal" << endl << flush;
	
	 
	  
	   
	//Write Data6
    fprintf(AmiraFile,"@7 # TopHatSignal\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
		lineCounter++;
		Structure* dendrite=(*pos);
		cout << "D:" << dendrite->GetName() << " "; 
		list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
		list< bla::Vector<double> >::iterator pos2;
		
		list <float> topHatTraces;
		list < vector<int> > positions;
		for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
		{
			bla::Vector<double> pos3d(4);//This will be the Logical Position!
			pos3d[1]=(*pos2)[1]/spaceing[1];
			pos3d[2]=(*pos2)[2]/spaceing[2];
			pos3d[3]=(*pos2)[3]/spaceing[3];
			pos3d[4]=(*pos2)[4];
			vector<int> posV;
			posV.push_back(pos3d[1]);
			posV.push_back(pos3d[2]);
			posV.push_back(pos3d[3]);
			
			positions.push_back(posV);
		}
		
		topHatTraces= GetTopHatTraces(positions, 10);
		list<float>::iterator tracePos;
		
		for (tracePos=topHatTraces.begin();tracePos!=topHatTraces.end();tracePos++)
		{
			
			float fluorTopHat=(*tracePos); 
			fprintf(AmiraFile, "%f\n",fluorTopHat);
		}
		
		
		
		
    }
    
	
	
	cout << "Write Dendrite Nr" << endl;
    //Write Data6, dend. nr.
    fprintf(AmiraFile,"@8 # Dendrite Nr.\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	int myDendNr;
	lineCounter++;
	Structure* dendrite=(*pos);
	int result=sscanf(dendrite->GetName(),"%*8s%d",&myDendNr);
	if (result!=1) myDendNr=0;
	//"Dendrite%d";Dendrite1450
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    bla::Vector<double> pos3d(4);//This will be the Logical Position!
	    fprintf(AmiraFile, "%d\n",myDendNr);
	}
    }
    
 
    cout << "Write Lines" << endl;
    //WriteLines
    fprintf(AmiraFile,"@9 # LineIndex\n");
    lineCounter=0;
    vectorCounter=0;
    for (pos=structureList.begin();pos!=structureList.end();++pos)
    {
	lineCounter++;
	Structure* dendrite=(*pos);
	list< bla::Vector<double> > pt3dList=dendrite->AccsessPoints3D();
	list< bla::Vector<double> >::iterator pos2;
	for (pos2= pt3dList.begin();pos2!=pt3dList.end();++pos2) 
	{
	    //nrOfVectors++;
	    vectorCounter++;
	    fprintf(AmiraFile, "%d ",vectorCounter-1);
	}
	fprintf(AmiraFile,"-1\n");
    }
	cout << "Finished Amira File" << endl;
    
    
    

    fclose(AmiraFile);

    return 0;
}















int DataImageInformation()
{
	InputImageType::RegionType region;
  InputImageType::SizeType size;

  region= inputImage->GetRequestedRegion();
  size = region.GetSize();

  cout << "Data Imgae Size:" << size[0] << "," << size[1]  << "," << size[2] << endl;

  

  /* Check Max Pixel Values */
  unsigned int max=0;
  unsigned int min=32768;
  
  for (unsigned int z=0;z<size[2];z++)
    for (unsigned int y=0;y<size[1];y++)
      for (unsigned int x=0;x<size[0];x++)
	{

	  InputImageType::IndexType pixelIndex;
	  pixelIndex[0]=x;
	  pixelIndex[1]=y;
	  pixelIndex[2]=z;
  
	  InputImageType::PixelType pixelValue= inputImage->GetPixel(pixelIndex); 
	  if (max<pixelValue) max=pixelValue;
	if (min>pixelValue) min=pixelValue;
	}
  
  std::cout << "Max PixelValue=" << max  << std::endl;


	return 0;
}




int CreateControllImage()
{
 
 /*Get Size of Input Image*/
  InputImageType::RegionType region;
  InputImageType::SizeType size;

  region= inputImage->GetRequestedRegion();
  size = region.GetSize();

  /*Create Temp Image Controll Image */
  typedef itk::RescaleIntensityImageFilter< InputImageType,  GrayImageType >		RescaleFilterType;
  RescaleFilterType::Pointer rescaler = RescaleFilterType::New();

  rescaler->SetOutputMinimum( 0 );
  rescaler->SetOutputMaximum( 255 );
  rescaler->SetInput( inputImage );
  rescaler->Update();
  GrayImageType::Pointer tmpImage= rescaler->GetOutput();


  /*Create Controll Image*/
  cout << "Create Controll Image" << endl;
 // ColorImageType::Pointer controllImage;
  controllImage =ColorImageType::New();
  controllImage->SetRegions(region);
  controllImage->Allocate();


 /* Copy Source in First Channel */

 cout << "Write Data into ControllImage" << endl;
   for (unsigned int z=0;z<size[2];z++)
    for (unsigned int y=0;y<size[1];y++)
      for (unsigned int x=0;x<size[0];x++)
	{

	  ColorImageType::IndexType pixelIndex;
	  pixelIndex[0]=x;
	  pixelIndex[1]=y;
	  pixelIndex[2]=z;
  
  	 InputImageType::PixelType pixelValue= tmpImage->GetPixel(pixelIndex); 
  
	  ColorImageType::PixelType colorPixelValue; 
	  colorPixelValue[0]=0;
	  colorPixelValue[1]=0;
	  colorPixelValue[2]=pixelValue;


	  controllImage->SetPixel(pixelIndex ,colorPixelValue); 
	  
	}


	return 0;
}


int writeAllDendrites()
{
    int error=0;
    int  dendritenumber=1;
    while (dendritenumber<1500)
    {
	error=IGORFile( dendritenumber );
	dendritenumber++;
    };
    return 0;
}




int ListMode()
{
    cout << "Enter List of Dendrite to put in one IGOR Wave File. Enter 0 to finish." << endl;
    int dendritenumber=1;
    list<int> dendriteList;
    int inputOK=1;
    while (inputOK>0)
    {
	dendriteList.empty();
    while (dendritenumber>0)
    {
	cout << "DendriteNr:";
	cin >> dendritenumber;
	cout << endl;
	if (dendritenumber>0) 
	    dendriteList.push_back(dendritenumber);
    };
	
	list<int>::iterator dendriticComps;
	cout << "Dendrite List:";
	for (dendriticComps=dendriteList.begin();dendriticComps!=dendriteList.end(); dendriticComps++)
	    {
	    cout << (*dendriticComps) << ", ";
	    };
	cout << endl;
	cout << "(A) ccept , (C)hange , (E) nd ?";
	char answer;
	cin >> answer;
	if (answer=='A' || answer=='a') inputOK=0;
	
	if (answer=='E' || answer=='e') 
	    return 0;		
	
    };
    
    cout << "Write Igor and Amira File" << endl;
    IGORFileForDendList(dendriteList);
    AmiraSelectedListDataWriter(dendriteList);
    cout << "Return to interactive mode" << endl;
    return 0;

}






int iteracativeMode()
{
    cout << " Start Interactive Mode (0 to quit, -1 to write all dendrites to igor file, -2 to write IGORList):" << endl;
    int dendritenumber=1;
    while (dendritenumber!=0)
    {
	printf("DendriteNr:");
	scanf("%d",&dendritenumber);
	printf("\n");
	if (dendritenumber==-1) writeAllDendrites();
	if (dendritenumber==-2) ListMode();
	if (dendritenumber>0)
	{
	    //gnuPlotFile(baseFilename, cellLoader, dendritenumber, spaceing, logicalSRange,  inputImage, controllImage );
	    IGORFile( dendritenumber );
	    plotValueOf( dendritenumber);	
	};   
    };
    
    return 0;
}





int ReadDataAndSetParameter()
{
    //Input Image and hoc File
    char inputImageFilename [2048];
    char inputHocFilename [2048];
    //Image Loader and Writer
    ReaderType::Pointer reader = ReaderType::New();
       
    
    //Default Values Settings
    spaceing[1]=0.36;
    spaceing[2]=0.36;
    spaceing[3]=0.36;
    
    //Base File Name
    
    
    int inputOK=1;
    while (inputOK)
    {
	cout << "Dendrite Analyzer programmed by Philip J. Broser at the Max Planck Institut for medical research." << endl;
	cout << "Contact: philip.broser@mpimf-heidelberg.mpg.de" << endl << endl;
	cout << "Input Image File Name:";
	cin >> inputImageFilename;
	cout << endl << "Hoc File Name:";
	cin >> inputHocFilename;
	cout << endl << "Base File Name for Naming Outputfiles, no characters like ._* etc. , max 12 characters";
	cout << endl << "Base File Name:";
	char baseHelp[20];
	sprintf(baseFilename, "%s.12", baseHelp);
	cin >> baseFilename;
	
	cout << endl << "Spaceing: dx:";
	cin >> spaceing[1];
	cout << "dy:" ;
	cin >> spaceing[2];
	cout << "dz:" ;
	cin >> spaceing[3];
	cout << endl;
	cout << "InputFilename:" << inputImageFilename << " Input Hoc File Name:" << inputHocFilename << endl;
	cout << "Base File Name:" << baseFilename << endl;
	cout <<  "Spaceing dx:" << spaceing[1] << " dy:" << spaceing[2] << " dz:" << spaceing[3] << endl;
	
	cout << "(A) ccept , (C)hange , (E) xit ?";
	char answer;
	cin >> answer;
	if (answer=='A' || answer=='a') inputOK=0;
	
	if (answer=='E' || answer=='e') 
	{
	    cout << "Good Bye!" << endl;
	    exit( 0 );
	}
    }
    
    
    //Parameter
    physicalScanningRangeQMXY=3;
    physicalScanningRangeQMZ=1;
    expdecayqmXY=2;
    expdecayqmZ=1;
    
    //OutPutFiles
    //Secondary Names 
   // sprintf(baseFilename,"%s_base",inputHocFilename);
    sprintf(outputImageFilename,"%s_controll.tif", baseFilename);
    
    //Read Hoc File
    int res=cellLoader.LoadHocFile(inputHocFilename);
    if (res) {cout << "error durring read hoc"<< endl;exit(1);}
    
    
    // Read Image Data
     reader->SetFileName( inputImageFilename );
    
    try
    {
	reader->Update();
    }
    catch ( itk::ExceptionObject &err )
    { 
	std::cout << "ReaderExeptionObject caught !" << std::endl;
	std::cout << "Error Reading input data image file !" << std::endl;
	std::cout << err << std::endl;
	exit(1);
    }
    
    
    
    inputImage=reader->GetOutput();
    CreateControllImage();
    
    return 0;
}







int DebugParameter()
{
    //Input Image and hoc File
    char inputImageFilename [2048];
    char inputHocFilename [2048];
    //Image Loader and Writer
    ReaderType::Pointer reader = ReaderType::New();
       
    
    //Default Values Settings
    spaceing[1]=0.36;
    spaceing[2]=0.36;
    spaceing[3]=0.36;
    
    //Base File Name
    
  
	
	sprintf(inputImageFilename,"060206D1.tif");
	sprintf(inputHocFilename,"060206D1.hoc");
	sprintf(baseFilename,"060206D1");
	
    
    
    //Parameter
    physicalScanningRangeQMXY=3;
    physicalScanningRangeQMZ=1;
    expdecayqmXY=2;
    expdecayqmZ=1;
    
    //OutPutFiles
    //Secondary Names 
   // sprintf(baseFilename,"%s_base",inputHocFilename);
    sprintf(outputImageFilename,"%s_controll.tif", baseFilename);
    
    //Read Hoc File
    int res=cellLoader.LoadHocFile(inputHocFilename);
    if (res) {cout << "error durring read hoc"<< endl;exit(1);}
    
    
    // Read Image Data
     reader->SetFileName( inputImageFilename );
    
    try
    {
	reader->Update();
    }
    catch ( itk::ExceptionObject &err )
    { 
	std::cout << "ReaderExeptionObject caught !" << std::endl;
	std::cout << "Error Reading input data image file !" << std::endl;
	std::cout << err << std::endl;
	exit(1);
    }
       
    
    
    inputImage=reader->GetOutput();
    CreateControllImage();
    
    return 0;
}










int writeDataFile()
{
    WriterType::Pointer writer = WriterType::New();

    //Write Amira File
    cout << " Write Amira File: d1: " << spaceing[1] << " d2:" << spaceing[2] << " d3:" << spaceing[3] << endl;
    AmiraDataWriter();
    
    
    /* Write Image File */
    cout << "Write File" << endl;
    writer->SetFileName(outputImageFilename);
    writer->SetInput( controllImage );
    writer->Update();
    
    return 0;
}





int main( int argc , char * argv[])
{ 
    
    ReadDataAndSetParameter();
	//DebugParameter();
    
	
	
	DataImageInformation();
    
    //Start Analysis
    writeDataFile();
    char buffer[1024];
    sprintf(buffer,"mkdir %s_IGORWaves",baseFilename);
    system(buffer);
    iteracativeMode();
    
   
    return 0;
}



   
