/*
 *  nervecell.h
 *  DendriteAnalyzer
 *
 *  Created by Philip Julian  Broser on Thu Jan 29 2004.
 *  Copyright (c) 2004 Max-Planck-Institut fuer medizinische Forschung. All rights reserved.
 * Jahnstrasse 29, D-69120 Heidelberg, EMail: philip.broser@mpimf-heidelberg.mpg.de
 */
 
#include "nervecell.h"


//Structure
int Structure::IDCounter=0;

Structure::
Structure()
{
    IDCounter++;
    id=IDCounter;
    kind=0;
    proximal=NULL;
    distal=NULL;
  
    base=0; // usually Structure is compartemt based
    sprintf(name,"noName");
}


Structure::
~Structure()
{
}


int 
Structure::
SetName(char *lName)
{
    strcpy(name,lName);
    return 0;
}




int
Structure::
SetProximalLink(Link *link)
{
    proximal=link;
    return 0;
}


int
Structure::
SetDistalLink(Link *link)
{
    distal=link;
    return 0;
}

ostream &operator<<(ostream &ostr, const Structure &structure)
{
	ostr << "This opperator is empty yet!" << endl;
    return ostr;
};





/*! This functions compares the name of the structure with the supposed Name returns 1 if the names are euqal
*/
int 
Structure::
IsThisMyName(char *supposedName) 
{
    if (strcmp(name,supposedName)==0) return 1;
    return 0;
}


int 
Structure::
addPoint3D(bla::Vector<double> &pt3d)
{
    //Start from proximal vectors continue to distal
    pt3dPoints.push_back(pt3d);
    
    return 0;
}



//Cellbody
Cellbody::
Cellbody() : Structure()
{
    kind=CELLBODY;
}

//Dendrite
Dendrite::
Dendrite()
{
    kind=DENDRITE;
}


//Button
Button::
Button()
{
    kind=BUTTON;
}


//Link
int Link::IDCounter=0;

Link::
Link()
{
    IDCounter++;
    id=IDCounter;
    proximal=NULL;
    sprintf(name,"noName");
};

int
Link::
SetProximalStructure(Structure *prox)
{
    proximal=prox;
    return 0;

}

int
Link::
AddDistalStructure(Structure *dist)
{
    distal.push_back(dist);
    return 0;
}



ostream &operator<<(ostream &ostr, const Link &link)
{
    //ostr << "[ Link:" << link.id;
    //ostr << " Conected to:";
    list<Structure*>::const_iterator  pos;
    for(pos=link.distal.begin();pos!=link.distal.end();++pos)
        ostr << **pos;
    //ostr << "]";


    return ostr;
};








int 
Link::
IsThisMyName(char *supposedName) // returns 1 if its the name of the link
{
    if (strcmp(name,supposedName)==0) return 1;
    return 0;

}




int 
Link::
SetName(char *lName)
{
    strcpy(name,lName);
    return 0;
}








