
#ifndef ITKTYPES
#define ITKTYPES

#if defined(_MSC_VER)
#pragma warning ( disable : 4786 )
#endif

#include "itkImage.h"
#include <iostream>
// zum Lesen und Schreiben von Bildern
#include "itkImageFileReader.h"
#include "itkImageFileWriter.h"
#include "itkTIFFImageIO.h"
#include "itkRGBPixel.h"
#include "itkRescaleIntensityImageFilter.h"

//Definition of itk Types
  typedef unsigned int		 FluorValueDataType;
  typedef unsigned int 		 PixelType12bit;
  typedef unsigned char 	 PixelType8bit;
  typedef itk::RGBPixel < unsigned char > PixelTypeColor8bit;
  
  const unsigned int             Dimension = 3; 

  typedef itk::Image< PixelType12bit, Dimension >       InputImageType;
  typedef InputImageType::Pointer InputImageTypePointer;
  typedef itk::Image< PixelType8bit, Dimension >       GrayImageType;

  typedef itk::Image< PixelTypeColor8bit, Dimension > 	ColorImageType;


  typedef itk::ImageFileReader< InputImageType >			ReaderType;
  typedef itk::ImageFileWriter< ColorImageType >			WriterType;
  
  typedef itk::ImageRegionConstIterator< GrayImageType > GrayConstIteratorType;
  typedef itk::ImageRegionIterator< ColorImageType > ColorIteratorType;


	typedef FluorValueDataType	NeuraDataType;

	const short verbose=1;

#endif
